"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const postcss_1 = __importDefault(require("postcss"));
const _types_1 = require("./@types");
const options_1 = require("./utilities/options");
const parser_1 = require("./rules/parser");
const rules_1 = require("./utilities/rules");
var _types_2 = require("./@types");
exports.Mode = _types_2.Mode;
exports.Source = _types_2.Source;
const transformer = (options = {}) => ((css) => {
    const optionsParsed = options_1.parseOptions(options);
    const appends = parser_1.parseRules(css, optionsParsed);
    appends.forEach(({ rule, ruleLTR, ruleRTL }) => {
        if (optionsParsed.mode === _types_1.Mode.combined) {
            rule.after(ruleRTL);
            rules_1.parseRule(ruleRTL);
            rule.after(ruleLTR);
            rules_1.parseRule(ruleLTR);
        }
        else {
            rule.after(ruleLTR || ruleRTL);
            rules_1.parseRule(ruleLTR || ruleRTL);
        }
        if (rule.nodes.length === 0) {
            rule.remove();
        }
    });
});
exports.default = postcss_1.default.plugin('postcss-rtlcss', transformer);
